"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TTreeBuilder = void 0;

var _collapse = require("./flow/collapse");

var _hoist = require("./flow/hoist");

var _translate = require("./flow/translate");

var _htmlparser = require("htmlparser2");

var _cssProcessor = require("@native-html/css-processor");

var _TStylesMerger = require("./styles/TStylesMerger");

var _defaults = require("./styles/defaults");

var _TStyles = require("./styles/TStyles");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class TTreeBuilder {
  constructor(options) {
    var _options$stylesConfig;

    _defineProperty(this, "htmlParserOptions", void 0);

    _defineProperty(this, "dataFlowParams", void 0);

    const stylesConfig = { ..._defaults.defaultStylesConfig,
      ...(options === null || options === void 0 ? void 0 : options.stylesConfig),
      baseStyle: { ..._defaults.defaultStylesConfig.baseStyle,
        ...(options === null || options === void 0 ? void 0 : (_options$stylesConfig = options.stylesConfig) === null || _options$stylesConfig === void 0 ? void 0 : _options$stylesConfig.baseStyle)
      }
    };
    const stylesMerger = new _TStylesMerger.TStylesMerger(stylesConfig, { ..._cssProcessor.defaultCSSProcessorConfig,
      ...(options === null || options === void 0 ? void 0 : options.cssProcessorConfig)
    });
    this.htmlParserOptions = {
      decodeEntities: true,
      ...(options === null || options === void 0 ? void 0 : options.htmlParserOptions)
    };
    this.dataFlowParams = {
      stylesMerger: stylesMerger,
      baseStyles: new _TStyles.TStyles(stylesMerger.compileStyleDeclaration(stylesConfig.baseStyle))
    };
  }

  buildTTree(html) {
    const documentTree = (0, _htmlparser.parseDOM)(html, this.htmlParserOptions);
    const tdoc = (0, _translate.translateDocument)(documentTree, this.dataFlowParams);
    return (0, _collapse.collapse)((0, _hoist.hoist)(tdoc));
  }

}

exports.TTreeBuilder = TTreeBuilder;
//# sourceMappingURL=TTreeBuilder.js.map