"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HTMLElementModel = void 0;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// deprecated, behaves like pre
// Attribute for object
const phrasingCategories = ['textual', 'edits'];
const translatableBlockCategories = ['embedded', 'tabular', 'grouping', 'sectioning', 'custom'];

class HTMLElementModel {
  constructor({
    tagName,
    category,
    isOpaque,
    isVoid,
    defaultUACSSProcessedProps: defaultCSSPropsRegistry,
    getUADerivedCSSProcessedPropsFromAttributes: getDerivedStylesFromAttributes
  }) {
    _defineProperty(this, "tagName", void 0);

    _defineProperty(this, "isOpaque", void 0);

    _defineProperty(this, "isDocument", void 0);

    _defineProperty(this, "isAnchor", void 0);

    _defineProperty(this, "isPhrasing", void 0);

    _defineProperty(this, "isTranslatableBlock", void 0);

    _defineProperty(this, "isVoid", void 0);

    _defineProperty(this, "defaultCSSProcessedProps", void 0);

    _defineProperty(this, "_getDerivedStylesFromAttributes", void 0);

    this.tagName = tagName;
    this.isOpaque = isOpaque !== null && isOpaque !== void 0 ? isOpaque : category === 'embedded';
    this.isVoid = isVoid !== null && isVoid !== void 0 ? isVoid : false;
    this.isAnchor = category === 'anchor';
    this.isDocument = tagName === 'html';
    this.isPhrasing = phrasingCategories.indexOf(category) !== -1;
    this.isTranslatableBlock = translatableBlockCategories.indexOf(category) !== -1;
    this.defaultCSSProcessedProps = defaultCSSPropsRegistry || null;
    this._getDerivedStylesFromAttributes = getDerivedStylesFromAttributes;
  }

  getUADerivedCSSProcessedPropsFromAttributes(attributes) {
    if (this._getDerivedStylesFromAttributes) {
      return this._getDerivedStylesFromAttributes(attributes);
    }

    return null;
  }

}

exports.HTMLElementModel = HTMLElementModel;
//# sourceMappingURL=HTMLElementModel.js.map