import { TDocument } from './tree/TDocument';
import { ParserOptions as HTMLParserOptions } from 'htmlparser2';
import { CSSProcessorConfig } from '@native-html/css-processor';
import { StylesConfig } from './styles/types';
export interface TTreeBuilderOptions {
    /**
     * Customization for CSS inline processing.
     */
    readonly cssProcessorConfig?: Partial<CSSProcessorConfig>;
    /**
     * Options for htmlparser2 library parser.
     */
    readonly htmlParserOptions?: Readonly<HTMLParserOptions>;
    /**
     * Various configuration for styling.
     */
    readonly stylesConfig?: StylesConfig;
}
export declare class TTreeBuilder {
    private htmlParserOptions;
    private dataFlowParams;
    constructor(options?: TTreeBuilderOptions);
    buildTTree(html: string): TDocument;
}
